import sk.thenet.plustd.audio.music.*;

class MainNoise {
	public static function main(){
		makeMeow();
	}
	
	public static function makeMeow():MusicManager {
		var btempo:Float = 240;
		var mng = new MusicManager([
			new MMIWave(MMIWave.WT_TRIANGLE),
			new MMIWave(MMIWave.WT_SQUARE),
			new MMIWave(MMIWave.WT_SINE),
			new MMINoise(),
			new MMIWave(MMIWave.WT_SINE)
		], []);
		
		mng.instruments[0].volume = .13;
		mng.instruments[1].volume = .08;
		cast(mng.instruments[1], MMIWave).duty = .61;
		mng.instruments[2].volume = .30;
		cast(mng.instruments[2], MMIWave).duty = .75;
		mng.instruments[3].volume = .09;
		mng.instruments[4].volume = .14;
		cast(mng.instruments[4], MMIWave).duty = .5;
		
		mng.addSection("surfrock", 0, [
			MMPatternBasic.fromNotes(
			  "STP --- --- --- --- --- --- --- "
			+ "--- --- A-5;vol2 A-5;vol2 --- G-5;vol2 --- F#5;vol2 "
			+ "E-5;vol2 --- --- A-5;vol2 G-5;vol2 G-5;vol2 F#5;vol2 F#5;vol2 "
			+ "E-5;vol2 --- A-5;vol2 A-5;vol2 G-5;vol2 G-5;vol2 F#5;vol2 F#5;vol2 "
			+ "A-5;vol2 A-5;vol2 D-3;vol2 D-3;vol2 C-3;vol2 C-3;vol2 H-5;vol2 H-5;vol2 "
			+ "A-5;vol2 A-5;vol2 D-3;vol2 D-3;vol2 C-3;vol2 C-3;vol2 H-5;vol2 H-5;vol2 "
			+ "E-5;vol2 E-5;vol2 A-5;vol2 A-5;vol2 G-5;vol2 G-5;vol2 F#5;vol2 F#5;vol2 "
			+ "E-5;vol2 E-5;vol2 A-5;vol2 A-5;vol2 G-5;vol2 G-5;vol2 F#5;vol2 F#5;vol2 "
			+ "H-5;vol2 H-5;vol2 E-3;vol2 E-3;vol2 D#3;vol2 D#3;vol2 D-3;vol2 D-3;vol2 "
			+ "A-5;vol2 A-5;vol2 D-3;vol2 D-3;vol2 C#3;vol2 C#3;vol2 C-3;vol2 C-3;vol2 "
			+ "E-5;vol2 E-5;vol2 A-5;vol2 A-5;vol2 G-5;vol2 G-5;vol2 F#5;vol2 F#5;vol2 "
			+ "E-5;vol2 E-5;vol2 A-5;vol2 A-5;vol2 G-5;vol2 G-5;vol2 F#5;vol2 F#5;vol2", btempo),
			MMPatternBasic.fromNotes(
				  "STP --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- "
				+ "--- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- "
				+ "--- --- --- --- --- --- E-4;arp1,5,1,.25 --- E-4;arp1,5,1,.25 --- STP --- E-4;arp1,3,1,.15 --- STP --- "
				+ "--- --- --- --- --- --- --- --- --- --- --- --- --- E-4 --- --- "
				+ "--- --- --- E-4;slj-10,4 --- --- --- G-4 --- E-4 STP --- --- --- --- --- "
				+ "--- E-3 --- E-4;slj-7,4 --- --- --- G-4 --- E-4 STP E-4;arp1,5,1,.5 STP --- --- --- "
				+ "--- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- "
				+ "--- --- --- E-4 --- --- D#4 --- G-4 E-4 --- STP E-4 --- STP G-4;vol5 "
				+ "--- --- --- --- G-3 STP --- --- --- --- --- --- --- --- --- G-4;vol3 "
				+ "--- G-4 --- H-4 --- G-4 --- H-4 --- E-5;arp6,10,0,.15 --- STP --- --- --- --- "
				+ "--- G-4 --- H-4 --- G-4 --- H-4 --- E-5 E-4 E-2 E-3 STP --- --- "
				+ "--- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- " +
				  "--- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- "
				+ "E-4;vol1 --- --- --- --- --- F-4;arp8,1,.5 E-4 --- STP --- E-3;vol1 E-3;vol1 E-3;vol1 E-3;vol1 STP --- "
				+ "E-4;vol1 --- --- --- --- F-4;arp8,1,.5 G-4 --- --- STP --- E-3;vol1 E-3;vol1 E-3;vol1 G-3;vol1 STP --- "
				+ "E-4;vol1;arp8,1,2,.3 --- --- --- F-4;arp8,1,.5 E-4 --- --- --- STP --- E-3;vol1 E-3;vol1 E-3;vol1 E-3;vol1 STP --- "
				+ "E-4;vol1 --- F-4;arp8,1,.5 G-4 --- --- G-3 G-5 G-4 STP --- E-3;vol1 E-3;vol1 E-3;vol1 G-3;vol1 STP --- "
				+ "A-4 A-4;vol2 --- G-4;VOL1 G-4;vol2 --- D-4;VOL1 D-2;vol2 --- A-4 --- STP A-4;vol1 A-4;vol1 A-4;vol1 "
				+ "A-4 A-4;vol2 --- G-4;VOL1 G-4;vol2 --- D-4;VOL1 D-2;vol2 --- A-4 --- STP A-4;vol1 A-4;vol1 A-4;vol1 "
				+ "E-4 E-4;vol2 --- D-4;VOL1 D-4;vol2 --- C-4;VOL1 C-2;vol2 --- E-4 --- STP E-4;vol1 E-4;vol1 E-5;vol1 "
				+ "E-4 E-4;vol2 --- D-4;VOL1 D-4;vol2 --- C-4;VOL1 C-2;vol2 --- E-4 --- STP E-5;vol1 E-4;vol1 E-4;vol1 "
				+ "--- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- "
				+ "E-4 E-4;vol2 --- D-4;VOL1 D-4;vol2 --- C-4;VOL1 C-2;vol2 --- E-4 --- STP E-4;vol1 E-5;vol1 E-3;vol1 "
				+ "--- --- --- --- --- --- --- --- E-3;vol3 --- --- STP --- --- --- --- ", btempo * 2),
			MMPatternBasic.fromNotes(
				  "E-2;vol2 E-2;vol2 A-2;vol2 A-2;vol2 G-2;vol2 G-2;vol2 F#2;vol2 F#2;vol2 "
				+ "E-2;vol2 E-2;vol2 A-2;vol2 A-2;vol2 G-2;vol2 G-2;vol2 F#2;vol2 F#2;vol2 "
				+ "E-2;vol2 E-2;vol2 A-2;vol2 A-2;vol2 G-2;vol2 G-2;vol2 F#2;vol2 F#2;vol2 "
				+ "E-2;vol2 E-2;vol2 A-2;vol2 A-2;vol2 G-2;vol2 G-2;vol2 F#2;vol2 F#2;vol2 "
				+ "A-2;vol2 A-2;vol2 D-3;vol2 D-3;vol2 C-3;vol2 C-3;vol2 H-2;vol2 H-2;vol2 "
				+ "A-2;vol2 A-2;vol2 D-3;vol2 D-3;vol2 C-3;vol2 C-3;vol2 H-2;vol2 H-2;vol2 "
				+ "E-2;vol2 E-2;vol2 A-2;vol2 A-2;vol2 G-2;vol2 G-2;vol2 F#2;vol2 F#2;vol2 "
				+ "E-2;vol2 E-2;vol2 A-2;vol2 A-2;vol2 G-2;vol2 G-2;vol2 F#2;vol2 F#2;vol2 "
				+ "H-2;vol2 H-2;vol2 E-3;vol2 E-3;vol2 D#3;vol2 D#3;vol2 D-3;vol2 D-3;vol2 "
				+ "A-2;vol2 A-2;vol2 D-3;vol2 D-3;vol2 C#3;vol2 C#3;vol2 C-3;vol2 C-3;vol2 "
				+ "E-2;vol2 E-2;vol2 A-2;vol2 A-2;vol2 G-2;vol2 G-2;vol2 F#2;vol2 F#2;vol2 "
				+ "E-2;vol2 E-2;vol2 A-2;vol2 A-2;vol2 G-2;vol2 G-2;vol2 F#2;vol2 STP", btempo),
			MMPatternBasic.fromNotes(
				  "STP --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- "
				+ "--- --- --- --- --- --- TRG STP TRG STP --- --- TRG STP --- --- "
				+ "--- --- --- --- --- --- TRG STP TRG STP --- --- TRG STP --- --- "
				+ "--- --- --- --- --- --- TRG STP TRG STP --- --- TRG STP --- --- "
				+ "--- --- --- --- --- --- TRG STP TRG STP --- --- TRG STP --- --- "
				+ "--- --- --- --- --- --- TRG STP TRG STP --- --- TRG STP --- --- "
				+ "--- --- --- --- --- --- TRG STP TRG STP --- --- TRG STP --- --- "
				+ "--- --- --- --- --- --- TRG STP TRG STP --- --- TRG STP --- --- "
				+ "TRG STP TRG STP TRG STP TRG STP TRG STP TRG STP TRG STP TRG STP "
				+ "TRG STP TRG STP TRG STP TRG STP --- --- TRG STP --- --- --- --- "
				+ "--- --- --- --- --- --- TRG STP TRG STP --- --- TRG STP --- --- "
				+ "--- --- --- --- --- --- TRG STP TRG STP --- --- TRG STP --- ---", btempo * 2),
			MMPatternBasic.fromNotes(
				  "STP --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- "
				+ "E-1;sli-3,1 STP --- --- --- --- --- --- --- --- --- E-1;sli-3,1 STP --- --- --- "
				+ "E-1;sli-3,1 STP --- --- --- --- --- --- --- --- --- E-1;sli-3,1 STP --- --- --- "
				+ "E-1;sli-3,1 STP --- --- --- --- --- --- --- --- --- E-1;sli-3,1 STP --- --- --- "
				+ "E-1;sli-3,1 STP --- --- --- --- --- --- --- --- --- E-1;sli-3,1 STP --- --- --- "
				+ "E-1;sli-3,1 STP --- --- --- --- --- --- --- --- --- E-1;sli-3,1 STP --- --- --- "
				+ "E-1;sli-3,1 STP --- --- --- --- --- --- --- --- --- E-1;sli-3,1 STP --- --- --- "
				+ "E-1;sli-3,1 STP --- --- --- --- --- --- --- --- --- E-1;sli-3,1 STP --- --- --- "
				+ "E-1;sli-3,1 STP --- --- --- --- --- --- --- --- --- E-1;sli-3,1 STP --- --- --- "
				+ "E-1;sli-3,1 STP --- --- --- --- --- --- --- --- --- E-1;sli-3,1 STP --- --- --- "
				+ "E-1;sli-3,1 STP --- --- --- --- --- --- --- --- --- E-1;sli-3,1 STP --- --- ---", btempo * 2),
		], []);
		mng.saveProgression(["surfrock"]);
		return mng;
	}
}