package game;

import sk.thenet.bmp.*;

@:bitmap("assets/font.png") class AssetFont extends flash.display.BitmapData {}
@:bitmap("assets/game.png") class AssetGame extends flash.display.BitmapData {}
@:bitmap("assets/gui.png") class AssetGUI extends flash.display.BitmapData {}
@:bitmap("assets/intro.png") class AssetIntro extends flash.display.BitmapData {}

class Assets {
	public static var aGame:BitmapData;
	public static var aGameHurt:BitmapData;
	public static var aGUI:BitmapData;
	public static var aIntro:BitmapData;
	public static var fFontHi:BitmapFont;
	public static var fFontMi:BitmapFont;
	public static var fFontLo:BitmapFont;
	
	public static function init():Void {
		aGame = cast(new AssetGame(0, 0));
		aGUI = cast(new AssetGUI(0, 0));
		aIntro = cast(new AssetIntro(0, 0));
		
		aGameHurt = new BitmapData(aGame.width, aGame.height, 0);
		var hc = aGame.get(24, 0);
		var ov = aGame.getFullVector();
		var v = aGameHurt.getFullVector();
		for (i in 0...v.length){
			v[i] = (ov[i] & 0xFF000000 != 0 ? hc : 0);
		}
		aGameHurt.setFullVector(v);
		
		fFontHi = BitmapFont.makeMonospaced(cast(new AssetFont(0, 0)), 32, 32, 8, 16, -2).recolour(hc);
		fFontMi = BitmapFont.makeMonospaced(cast(new AssetFont(0, 0)), 32, 32, 8, 16, -2).recolour(aGame.get(8, 0));
		fFontLo = BitmapFont.makeMonospaced(cast(new AssetFont(0, 0)), 32, 32, 8, 16, -2).recolour(aGame.get(0, 0));
	}
}