package game;

import sk.thenet.FM;
import sk.thenet.app.*;
import sk.thenet.bmp.*;

class ECollect extends Entity {
	public static inline var CT_TREAT:Int = 0;
	public static inline var CT_LEVELR:Int = 1;
	public static inline var CT_LEVELL:Int = 2;
	public static inline var CT_LEVELN:Int = 3;
	public static inline var CT_LEVELF:Int = 4;
	public static inline var CT_LIFE:Int = 5;
	
	public var ctype:Int;
	public var ph:Int;
	public var phl:Int;
	public var ttl:Int;
	public var inertia:Int;
	public var vx:Float;
	public var vy:Float;
	public var rx:Float;
	public var ry:Float;
	public var bdsx:Int;
	
	public function new(ngs:GSGame, nx:Int, ny:Int, ntype:Int){
		super(Entity.ET_COLLECT, ngs);
		ctype = ntype;
		x = nx;
		y = ny;
		rx = x;
		ry = y;
		dotick = true;
		bdsx = 200;
		switch (ctype){
			case CT_TREAT:
			ttl = 140;
			bdx = 200;
			bdy = 112;
			bdw = 4;
			bdh = 4;
			bdox = -2;
			bdoy = -2;
			inertia = 60;
			vx = (Main.prng.nextFloat() - .5) * 4;
			vy = (Main.prng.nextFloat() - .5) * 4;
			ph = Main.prng.nextMod(6);
			phl = 6;
			case CT_LEVELR | CT_LEVELL | CT_LEVELN | CT_LEVELF:
			ttl = 360;
			bdx = 200;
			bdy = 125;
			bdw = 11;
			bdh = 15;
			bdox = -5;
			bdoy = -7;
			inertia = 600;
			vx = 0;
			vy = 1;
			ph = 0;
			phl = 5;
			bddyn = true;
			case CT_LIFE:
			ttl = 360;
			bdsx = 0;
			bdx = 0;
			bdy = 8;
			bdw = 16;
			bdh = 16;
			bdox = -8;
			bdoy = -8;
			inertia = 400;
			vx = 0;
			vy = 1;
			ph = 0;
			phl = 1;
		}
	}
	
	override public function render(bd:BitmapData):Void {
		if (ctype >= CT_LEVELR && ctype <= CT_LEVELF){
			bd.copyPixels(Assets.aGame, x + bdox, y + bdoy + 4, 200 + 11 * (ctype - CT_LEVELR), 140, 11, 9);
		}
	}
	
	override public function tick(st:SApp):Void {
		if (ph >= ttl){
			remove = true;
		} else if (ph >= ttl >> 1){
			visible = (ph % 2 == 0);
		}
		rx += vx;
		ry += vy;
		vx = (((gs.player.x - rx) / 20) + vx * inertia) / (inertia + 1);
		vy = (((gs.player.y - ry) / 20) + vy * inertia) / (inertia + 1);
		x = FM.floor(rx);
		y = FM.floor(ry);
		if (x >= gs.player.x + gs.player.hbx && x < gs.player.x + gs.player.hbx + gs.player.hbw
			&& y >= gs.player.y + gs.player.hby && y < gs.player.y + gs.player.hby + gs.player.hbh){
			if (ctype == CT_TREAT){
				if (gs.player.collectTreat()) remove = true;
			} else if (ctype >= CT_LEVELR && ctype <= CT_LEVELF){
				if (gs.player.collectLevel(ctype - CT_LEVELR)) remove = true;
			} else {
				if (gs.player.collectLife()) remove = true;
			}
			remove = true;
		}
		bdx = bdsx + ((ph >> 1) % phl) * bdw;
		ph++;
	}
}