package game;

import sk.thenet.FM;
import sk.thenet.app.*;
import sk.thenet.bmp.*;

class EEBossDog extends EEnemy {
	public static inline var BOSSHP:Int = 1000;
	
	public var offhx:Int = 0; // offset head
	public var offhy:Int = 0;
	public var offbx:Int = 0; // body
	public var offby:Int = 0;
	public var offlx:Int = 0; // legs
	public var offly:Int = 0;
	
	public var bdph:Int = 0; // bitmap part head
	public var bdpb:Int = 0; // body
	
	public var bobph:Int = 0; // head bob phase
	
	public var stg:Int = 0; // stage
	public var stgph:Int = 0; // stage phase
	
	public var bullets:Array<DogBullet> = [];
	
	public function new(ngs:GSGame, nspawner:Wave.Spawner, nmovefunc:Int->EEnemy->Void){
		super(ngs, nspawner, nmovefunc);
		bdx = 208;
		bdy = 152;
		bdw = 32;
		bdh = 32;
		bdox = -16;
		bdoy = -6;
		x = 120;
		y = -80;
		
		//y = 44;
		//stg = 8;
		//stgph = 0;
		
		bdreg = false;
		bddyn = true;
		
		score = 10000;
		
		gs.boss = true;
		gs.bosshp = hp = BOSSHP;
	}
	
	override public function render(bd:BitmapData):Void {
		bd.copyPixels(Assets.aGame, x + offlx - 12, y + offly + 18, 208, 248, 24, 40);
		bd.copyPixels(Assets.aGame, x + offbx - 27, y + offby, 208 + bdpb * 56, 184, 56, 64);
		var bobx:Int = 0;
		var boby:Int = 0;
		if (bdph == 0){
			bobx = (bobph >= 8 ? (bobph >= 16 ? (bobph >= 24 ? -1 : 0) : 1) : 0);
			boby = (bobph >= 8 ? (bobph >= 16 ? (bobph >= 24 ? 1 : 0) : 1) : 0);
		}
		bd.copyPixels(hurt != 0 ? Assets.aGameHurt : Assets.aGame,
			x + offhx - 13 + bobx,
			y + offhy - 6 + boby,
			208 + (bdph << 5), 152, 32, 32);
	}
	
	public function filterBullets(a:DogBullet):Bool {
		return !a.ent.remove;
	}
	
	public function sts():Void {
		var ostg:Int = stg;
		while (stg == ostg){
			stg = Main.prng.nextMod(8) + 1;
		}
		stgph = 0;
	}
	
	override public function tick(st:SApp):Void {
		bullets = bullets.filter(filterBullets);
		for (b in bullets){
			switch (b.st){
				case 3 | 4: // bark
				b.x = b.ox + b.ph * 3 * Math.cos((b.arg + (b.st == 4 ? Math.sin(b.ph / 10) * 0.04 : 0)) * Math.PI * 2);
				b.y = b.oy + b.ph * 3 * Math.sin((b.arg + (b.st == 4 ? Math.sin(b.ph / 10) * 0.04 : 0)) * Math.PI * 2);
				case 5 | 6: // paw strike
				b.x = b.ox + (b.ph + 10) * 3 * Math.cos((b.arg + Math.sin(b.ph / (b.st == 5 ? -50 : 50)) * 0.1) * Math.PI * 2);
				b.y = b.oy + (b.ph + 10) * 3 * Math.sin((b.arg + Math.sin(b.ph / (b.st == 5 ? -30 : 30)) * 0.07) * Math.PI * 2);
				case 7: // jumparound
				b.x = b.ox + (b.ph + 3) * 6 * Math.cos((b.arg + Math.sin(b.ph / (b.st == 5 ? -50 : 50)) * 0.1) * Math.PI * 2);
				b.y = b.oy + (b.ph + 3) * 6 * Math.sin((b.arg + Math.sin(b.ph / (b.st == 5 ? -30 : 30)) * 0.07) * Math.PI * 2);
				case 8: // yawn
				b.x = b.ox + b.ph * (Math.cos(b.ph / 150) * 3) * Math.cos((b.arg) * Math.PI * 2);
				b.y = b.oy + b.ph * (Math.cos(b.ph / 150) * 3) * Math.sin((b.arg) * Math.PI * 2);
			}
			b.tick();
		}
		switch (stg){
			case 0: // arriving
			y++;
			stgph++;
			if (stgph >= 124){
				sts();
			}
			case 1 | 2: // leftright wave
			y = 44;
			x = 120 + FM.floor(Math.sin((stgph / 120) * Math.PI * 2) * (stg == 1 ? 80 : -80));
			offlx = -FM.floor(Math.cos((stgph / 120) * Math.PI * 2) * 4);
			stgph++;
			if (stgph % 30 == 0){
				for (i in 1...8){
					gs.addEntity(new EBullet(true, x, y, gs, EBullet.BT_BIGMOUSE1 + i));
				}
			}
			if (stgph >= 120){
				offlx = 0;
				sts();
			}
			case 3 | 4: // bark, barkharder
			y = 44;
			x = 120;
			stgph++;
			if (stgph >= 60){
				sts();
				bdph = 0;
			} else {
				if (stgph % 30 < 10){
					offhx = 0;
					bdph = 0;
				} else if (stgph % 30 < 15){
					offhx = -1;
					bdph = 1;
				} else if (stgph % 30 < 20){
					if (stgph % 30 == 15){
						Noises.playBark();
						for (i in 0...30){
							bullets.push(new DogBullet(stg, (i / 30) + (stgph > 30 ? 1 / 60 : 0), x, y, gs));
						}
					}
					offhx = -1;
					bdph = 2;
				} else if (stgph % 30 < 28){
					offhx = -1;
					bdph = 1;
				} else {
					offhx = 0;
					bdph = 0;
				}
			}
			case 5 | 6: // paw strike
			y = 44;
			stgph++;
			if (stgph < 20){
				x = 120 + stgph * (stg == 5 ? 4 : -4);
			} else if (stgph < 60){
				x = 120 + (stg == 5 ? 80 : -80);
				if (stgph < 40){
					bdpb = 1;
					bdph = 1;
				} else if (stgph < 50){
					if (stgph == 40){
						Noises.playCrush();
						for (i in 0...21){
							bullets.push(new DogBullet(stg, i / 40 + (stg == 5 ? .1 : -.1), x, y, gs));
						}
					}
					bdpb = 2;
					bdph = 1;
				} else {
					bdpb = 0;
					bdph = 0;
				}
			} else if (stgph < 80) {
				x = 120 + (20 - (stgph - 60)) * (stg == 5 ? 4 : -4);
			} else {
				sts();
			}
			case 7: // jumparound
			y = 44;
			stgph++;
			x = 120 + FM.floor(Math.sin((stgph / 120) * 2 * Math.PI) * 80);
			offlx = -FM.floor(Math.cos((stgph / 120) * Math.PI * 2) * 4);
			offhy = FM.floor((1 - Math.cos((stgph / 30) * Math.PI * 2)) * -10);
			offby = FM.floor((1 - Math.cos((stgph / 30 - 1 / 30) * Math.PI * 2)) * -10);
			offly = FM.floor((1 - Math.cos((stgph / 30 - 4 / 30) * Math.PI * 2)) * -10);
			if (offly > -7){
				bdpb = 3;
			} else {
				for (i in 0...5){
					bullets.push(new DogBullet(stg, i / 5 + (stgph % 30 >= 19 ? .1 : 0), x, y - offly, gs));
				}
				bdpb = 0;
			}
			if (stgph >= 360){
				sts();
				bdpb = 0;
			}
			case 8: // yawn
			stgph++;
			if (stgph < 16){
				if (stgph > 5){
					bdpb = 3;
				}
				y = 44 + stgph;
				offly = -stgph;
				offhy = stgph >> 3;
			} else if (stgph < 150){
				if (stgph == 20){
					offhx = -6;
					bdph = 2;
				} else if (stgph > 20){
					offhx += Main.prng.nextMod(3) - 1;
					offhx = FM.clampI(offhx, -8, -4);
				}
				var nbul = new DogBullet(stg, (stgph % 25) / 25 + ((stgph % 75) / 250), x, y + 14, gs);
				nbul.ttl = 230;
				nbul.ent.autorem = false;
				bullets.push(nbul);
				y = 60;
				offly = -16;
				offhy = 2;
			} else if (stgph >= 380 && stgph < 396){
				y = 44 + (16 - (stgph - 380));
				offly = -(16 - (stgph - 380));
				offhy = (16 - (stgph - 380)) >> 3;
				if (stgph > 388){
					bdpb = 0;
					bdph = 0;
					offhx = 0;
				}
			} else if (stgph >= 396){
				sts();
				y = 44;
				offly = 0;
				offhy = 0;
			}
		}
		
		if (hp <= 0){
			gs.scorelvl += score;
			gs.spawnExplosion(x, y, 30);
			gs.spawnExplosion(x + 30, y + 10, 30);
			gs.spawnExplosion(x - 10, y + 20, 30);
			Noises.playBossClear();
			remove = true;
			gs.boss = false;
			gs.bosshp = 0;
			for (b in bullets){
				b.ent.remove = true;
			}
			bullets = [];
		} else {
			if (stg == 0){
				hp = BOSSHP;
			}
			gs.bosshp = hp;
			ph++;
			bobph++;
			bobph %= 32;
			if (hurt > 0) hurt--;
		}
	}
}

class DogBullet {
	public var st:Int;
	public var ph:Int = 0;
	public var arg:Float;
	public var ox:Float;
	public var oy:Float;
	public var x:Float;
	public var y:Float;
	public var ent:EBullet;
	public var ttl:Int = 0;
	
	public function new(nst:Int, narg:Float, nx:Float, ny:Float, gs:GSGame){
		st = nst;
		arg = narg;
		x = ox = nx;
		y = oy = ny;
		ent = new EBullet(true, FM.floor(x), FM.floor(y), gs, EBullet.BT_DOG);
		gs.addEntity(ent);
	}
	
	public function tick():Void {
		ent.x = FM.floor(x);
		ent.y = FM.floor(y);
		ph++;
		if (ttl != 0 && ph >= ttl){
			ent.remove = true;
		}
	}
}