package game;

import sk.thenet.app.*;

class EEPopcorn extends EEnemy {
	public function new(ngs:GSGame, nspawner:Wave.Spawner, nmovefunc:Int->EEnemy->Void){
		super(ngs, nspawner, nmovefunc);
		bdx = 88;
		bdy = 8;
		bdw = 16;
		bdh = 16;
		bdox = -8;
		bdoy = -10;
		hp = 1;
	}
	
	override public function tick(st:SApp):Void {
		super.tick(st);
		var sph = ((ph >> 1) % 4);
		bdx = 88 + (sph < 3 ? sph << 4 : 16);
	}
}

class EEPBee extends EEPopcorn {
	public var shot:Bool = false;
	
	public function new(ngs:GSGame, nspawner:Wave.Spawner, nmovefunc:Int->EEnemy->Void){
		super(ngs, nspawner, nmovefunc);
		bdx = 136;
		bdy = 8;
		bdw = 16;
		bdh = 24;
		bdox = -8;
		bdoy = -10;
		hp = 1;
	}
	
	override public function tick(st:SApp):Void {
		super.tick(st);
		var sph = ((ph >> 1) % 4);
		bdx = 136 + (sph < 3 ? sph << 4 : 16);
		if (!shot && Main.prng.nextMod(100) == 0){
			shot = true;
			gs.addEntity(new EBullet(true, x, y + 4, gs, EBullet.BT_BEE_STINGER));
		}
	}
}

class EEPTile extends EEPopcorn {
	public function new(ngs:GSGame, nx:Int, ny:Int){
		super(ngs, null, null);
		x = nx;
		y = ny;
		bdx = 48 + Main.prng.nextMod(3) * 8;
		bdy = 184;
		bdw = 8;
		bdh = 8;
		bdox = 0;
		bdoy = 0;
		hp = 1;
	}
	
	override public function tick(st:SApp):Void {
		if (hp <= 0){
			Noises.playSplash();
			gs.spawnExplosion(x, y, 3);
			gs.scorelvl += 10;
			remove = true;
		}
		y++;
		if (y >= 330){
			remove = true;
		}
	}
}

class EEPScratchpost extends EEPopcorn {
	public var rew:Int;
	
	public function new(ngs:GSGame, nx:Int, ny:Int, nrew:Int){
		super(ngs, null, null);
		x = nx;
		y = ny;
		bdx = 184;
		bdy = 0;
		bdw = 32;
		bdh = 40;
		bdox = -12;
		bdoy = -20;
		hp = 40;
		rew = nrew;
	}
	
	override public function tick(st:SApp):Void {
		if (hp <= 0){
			gs.spawnExplosion(x, y - 10, 50);
			gs.addEntity(new ECollect(gs, x, y + 10, ECollect.CT_LEVELR + rew));
			Noises.playSplash();
			gs.scorelvl += 50;
			remove = true;
		}
		y++;
		if (y >= 330){
			remove = true;
		}
	}
}