package game;

import haxe.ds.Vector;
import sk.thenet.FM;
import sk.thenet.app.*;
import sk.thenet.bmp.*;

class GSGame extends SSApp {
	public var ent:Entity;
	public var entsep:Array<Entity>;
	public var player:EPlayer;
	public var bds:Array<BitmapData>;
	public var pal:Array<UInt>;
	public var stars:Vector<Star>;
	public var shake:Int;
	public var lvl:Level;
	public var lvlover:Bool;
	public var lvloph:Int;
	public var spawners:Array<Wave.Spawner>;
	public var particles:Vector<Particle>;
	public var particles_fg:Vector<Particle>;
	public var hint:Array<String>;
	public var hintsh:Bool;
	public var hinti:Int;
	public var hintsub:Int;
	public var mtsx:Array<Int>;
	public var mtsy:Array<Int>;
	public var mtsi:Int;
	public var mtsl:Int;
	public var scorelvl:Int;
	public var scoretot:Int;
	public var mplaying:flash.media.SoundChannel;
	public var boss:Bool;
	public var bosshp:Int;
	public var cont:Bool;
	
	public function new(nstater){
		super("game", nstater);
		bds = [
			Assets.aGame,
			Assets.aGameHurt
		];
		pal = [
			for (i in 0...11){
				bds[0].get(i * 8, 0);
			}
		];
	}
	
	public function addEntity(ent:Entity):Entity {
		ent.n = entsep[ent.type].n;
		entsep[ent.type].n = ent;
		return ent;
	}
	
	public function setLevel(num:Int):Void {
		entsep = [
			new Entity(Entity.ET_PLAYER, this),
			new Entity(Entity.ET_ENEMY, this),
			new Entity(Entity.ET_COLLECT, this),
			new Entity(Entity.ET_PLAYER_BULLET, this),
			new Entity(Entity.ET_ENEMY_BULLET, this),
			new Entity(Entity.ET_NONE, this)
		];
		for (ei in 0...(entsep.length - 1)){
			entsep[ei].n = entsep[ei + 1];
			entsep[ei].layer = true;
		}
		entsep[entsep.length - 1].layer = true;
		ent = entsep[0];
		if (cont && player != null){
			var oldp = player;
			player = cast(addEntity(new EPlayer(this)), EPlayer);
			player.hp = oldp.hp;
			player.lives = oldp.lives;
			for (i in 0...4)
				player.shpow[i] = oldp.shpow[i];
		} else {
			player = cast(addEntity(new EPlayer(this)), EPlayer);
		}
		cont = false;
		lvl = new Level(this, num);
		lvlover = false;
		lvloph = 0;
		spawners = [];
		particles = new Vector<Particle>(2000);
		for (pi in 0...particles.length){
			particles[pi] = new Particle();
		}
		particles_fg = new Vector<Particle>(2000);
		for (pi in 0...particles_fg.length){
			particles_fg[pi] = new Particle();
		}
		hint = [];
		hintsh = false;
		hinti = 0;
		hintsub = 0;
		mtsx = [];
		mtsy = [];
		mtsi = 0;
		mtsl = 0;
		scoretot += scorelvl;
		scorelvl = 0;
		boss = false;
		bosshp = 0;
		if (mplaying != null){
			mplaying.stop();
		}
		mplaying = Noises.playLoopBoss();
	}
	
	override public function to():Void {
		mplaying = null;
		stars = new Vector<Star>(300);
		for (i in 0...stars.length){
			stars[i] = new Star();
		}
		cont = false;
		shake = 0;
		scoretot = 0;
		scorelvl = 0;
		setLevel(0);
	}
	
	function sfilter(a:Wave.Spawner):Bool {
		return !a.remove;
	}
	
	public function spawnExplosion(x:Int, y:Int, sz:Int):Void {
		for (p in particles){
			if (p.type == 0){
				p.type = Particle.PT_EXPLOSION;
				p.x = x;
				p.y = y;
				p.vx = Main.prng.nextMod(3) - 1;
				p.vy = Main.prng.nextMod(3) - 1;
				p.vsx = Main.prng.nextMod(5) - 2;
				p.vsy = Main.prng.nextMod(5) - 2;
				p.vrn = Main.prng.nextMod(3);
				p.ttl = Main.prng.nextMod(10) + 5;
				sz--;
				if (sz < 0) return;
			}
		}
	}
	
	public function spawnBulletSplash(x:Int, y:Int, vy:Int):Void {
		var sz:Int = 5;
		for (p in particles){
			if (p.type == 0){
				p.type = Particle.PT_BULLET_SPLASH;
				p.x = x - 4;
				p.y = y - 4;
				p.vx = Main.prng.nextMod(3) - 1;
				p.vy = Main.prng.nextMod(4) - (vy > 0 ? 2 : 1);
				p.vsx = Main.prng.nextMod(5) - 2;
				p.vsy = Main.prng.nextMod(5) - 2;
				p.vrn = Main.prng.nextMod(8);
				p.ttl = Main.prng.nextMod(4) + 2;
				sz--;
				if (sz < 0) return;
			}
		}
	}
	
	public function spawnMousetail(x:Int, y:Int):Void {
		mtsx.push(x);
		mtsy.push(y);
		mtsl++;
	}
	
	public function blockScreen():Void {
		for (i in 0...6){
			var sz:Int = 0;
			var pos_x:Array<Int> = [];
			var pos_y:Array<Int> = [];
			var vrn:Int = 136 + (i % 3) * 40;
			var ox:Int = Main.prng.nextMod(100) - 50;
			var oy:Int = Main.prng.nextMod(320) - 160;
			for (y in 0...40) for (x in 0...40){
				if (bds[0].get(vrn + x, 72 + y) & 0xFF000000 != 0){
					pos_x.push(x * 6 + ox);
					pos_y.push(y * 6 + oy);
					sz++;
				}
			}
			for (p in particles_fg){
				if (p.type == 0){
					p.type = Particle.PT_BIRD_POO;
					p.x = pos_x.shift();
					p.y = pos_y.shift();
					p.vrn = Main.prng.nextMod(3);
					p.ttl = Main.prng.nextMod(40) + 14;
					sz--;
					if (sz < 0) break;
				}
			}
		}
	}
	
	override public function tick():Void {
		var ce = null;
		
		if (!hintsh && !lvlover){
			if (!boss) lvl.tick();
			if (lvl.ph >= lvl.len){
				lvlover = true;
				lvloph = 300;
			}
			for (s in spawners){
				s.tick();
			}
			spawners = spawners.filter(sfilter);
			ce = ent;
			var pe = null;
			while (ce != null){
				if (ce.dotick){
					ce.tick(stater);
				}
				if (ce.remove){
					pe.n = ce.n;
				} else {
					pe = ce;
				}
				ce = ce.n;
			}
		}
		
		stater.bd.fill(pal[0]);
		for (s in stars){
			if (!hintsh){
				s.ph++;
				s.bph++;
				if (s.ph >= s.sp){
					s.ph = 0;
					s.y++;
					if (s.y >= 320){
						s.reset();
					}
				}
			}
			if (s.bph >= s.bf){
				s.bph = 0;
				stater.bd.set(s.x, s.y, pal[2]);
			} else {
				stater.bd.set(s.x, s.y, pal[1]);
			}
			if (s.sz == 2){
				stater.bd.set(s.x + 1, s.y, pal[1]);
				stater.bd.set(s.x, s.y + 1, pal[1]);
				stater.bd.set(s.x + 1, s.y + 1, pal[1]);
			} else if (s.sz == 3){
				stater.bd.set(s.x - 1, s.y + 1, pal[1]);
				stater.bd.set(s.x, s.y + 1, pal[3]);
				stater.bd.set(s.x + 1, s.y + 1, pal[1]);
				stater.bd.set(s.x, s.y + 2, pal[1]);
			}
		}
		
		var lphy:Int = lvl.ph >> 3;
		var lphsy:Int = lvl.ph % 8;
		for (y in 0...43){
			for (x in 0...30){
				if (lphy + y >= 0 && lphy + y < lvl.tlen && lvl.tdata[x + (y + lphy) * 30] == 1){
					if (lvl.tbig[x + (y + lphy) * 30]){
						stater.bd.copyPixels(bds[0], x << 3, 320 - (y << 3) + lphsy - 8, 48 + (lvl.tvrn[x + (y + lphy) * 30] << 4), 160, 16, 16);
					} else {
						stater.bd.copyPixels(bds[0], x << 3, 320 - (y << 3) + lphsy, 48 + (lvl.tvrn[x + (y + lphy) * 30] << 3), 176, 8, 8);
					}
				}
				if (!hintsh && y == 42 && lphsy == 0 && lphy + y >= 0 && lphy + y < lvl.tlen){
					switch (lvl.tdata[x + (y + lphy) * 30]){
						case 0x8000:
						hintsh = true;
						hint = lvl.hints[hinti++];
						case 2: addEntity(new EEPopcorn.EEPTile(this, x * 8, -16));
						case 0xFF00: addEntity(new EEPopcorn.EEPScratchpost(this, x * 8, -24, 0));
						case 0xFF01: addEntity(new EEPopcorn.EEPScratchpost(this, x * 8, -24, 1));
						case 0xFF02: addEntity(new EEPopcorn.EEPScratchpost(this, x * 8, -24, 2));
						case 0xFF03: addEntity(new EEPopcorn.EEPScratchpost(this, x * 8, -24, 3));
						case 0xFF10: addEntity(new EYarnball(x * 8, -24, this));
					}
				}
			}
		}
		
		ce = ent;
		var num = 0;
		while (ce != null){
			if (ce.layer && ce.type == Entity.ET_ENEMY){
				var mt_x:Array<Int> = [];
				var mt_y:Array<Int> = [];
				for (p in particles){
					if (p.type == 0 && mtsi < mtsl){
						p.type = Particle.PT_MOUSE_TAIL;
						p.x = mtsx[mtsi];
						p.y = mtsy[mtsi];
						p.ttl = 10;
						mtsi++;
					}
					if (p.type == Particle.PT_MOUSE_TAIL){
						if (p.ph >= p.ttl){
							p.reset();
							continue;
						}
						stater.bd.fillRect(p.x, p.y, 4, 4, pal[1]);
						mt_x.push(p.x);
						mt_y.push(p.y);
						if (!hintsh) p.ph++;
					}
				}
				for (i in 0...mt_x.length){
					stater.bd.fillRect(mt_x[i] + 1, mt_y[i] + 1, 1, 2, pal[3]);
					stater.bd.fillRect(mt_x[i] + 2, mt_y[i] + 1, 1, 2, pal[2]);
				}
				mtsx = [];
				mtsy = [];
				mtsi = 0;
				mtsl = 0;
			}
			if (ce.layer && ce.type == Entity.ET_PLAYER_BULLET){
				for (p in particles){
					if (p.type != Particle.PT_NONE){
						if (p.ph >= p.ttl){
							p.reset();
							continue;
						}
						switch (p.type){
							case Particle.PT_EXPLOSION:
							stater.bd.copyPixels(bds[0], p.x, p.y, 88 + ((p.ph >> 2) << 3), 24 + (p.vrn << 3), 8, 8);
							if (!hintsh){
								p.x += p.vx + (p.vsx != 0 ? (p.vsx > 0 ? (p.ph % p.vsx == 0 ? 1 : 0) : (p.ph % -p.vsx == 0 ? -1 : 0)) : 0);
								p.y += p.vy + (p.vsy != 0 ? (p.vsy > 0 ? (p.ph % p.vsy == 0 ? 1 : 0) : (p.ph % -p.vsy == 0 ? -1 : 0)) : 0);
								p.ph++;
							}
							case Particle.PT_BULLET_SPLASH:
							stater.bd.copyPixels(bds[0], p.x, p.y, 16 + (p.vrn << 3), 16, 8, 8);
							if (!hintsh){
								p.x += p.vx + (p.vsx != 0 ? (p.vsx > 0 ? (p.ph % p.vsx == 0 ? 1 : 0) : (p.ph % -p.vsx == 0 ? -1 : 0)) : 0);
								p.y += p.vy + (p.vsy != 0 ? (p.vsy > 0 ? (p.ph % p.vsy == 0 ? 1 : 0) : (p.ph % -p.vsy == 0 ? -1 : 0)) : 0);
								p.ph++;
							}
							case Particle.PT_MOUSE_TAIL:
							case _:
							if (!hintsh) p.ph++;
						}
					}
				}
			}
			if (!ce.layer && ce.visible){
				if (ce.bdreg){
					stater.bd.copyPixels(bds[ce.bd + (ce.hurt > 0 ? 1 : 0)], ce.x + ce.bdox, ce.y + ce.bdoy, ce.bdx, ce.bdy, ce.bdw, ce.bdh);
				}
				if (ce.bddyn){
					ce.render(stater.bd);
				}
				if (ce.hurt > 0 && !hintsh) ce.hurt--;
			}
			num++;
			ce = ce.n;
		}
		//trace(num);
		for (p in particles_fg){
			if (p.type != Particle.PT_NONE){
				if (p.ph >= p.ttl){
					p.reset();
					continue;
				}
				switch (p.type){
					case Particle.PT_BIRD_POO:
					stater.bd.copyPixels(bds[0], p.x - 3, p.y - 3 + (p.ttl - p.ph < 10 ? 10 - (p.ttl - p.ph) : 0), p.vrn * 8 + Main.prng.nextMod(3) * 8, 0, 6, 6);
					case _:
				}
				if (!hintsh) p.ph++;
			}
		}
		
		if (player.sheld == 20 && !hintsh){
			stater.bd.copyPixels(Assets.aGUI, 32, 64, 0, 8, 176, 176);
			Assets.fFontLo.render(stater.bd, "Regular", 36 + 1, 128 + 36 + 1, 100);
			Assets.fFontHi.render(stater.bd, "Regular", 36, 128 + 36, 100);
			Assets.fFontLo.render(stater.bd, " lvl." + player.shpow[0], 36 + 1, 128 + 36 + 1 + 12, 100);
			Assets.fFontMi.render(stater.bd, " lvl." + player.shpow[0], 36, 128 + 36 + 12, 100);
			
			Assets.fFontLo.render(stater.bd, "Catloaf", 36 + 121 + 1, 128 + 36 + 1, 100);
			Assets.fFontHi.render(stater.bd, "Catloaf", 36 + 121, 128 + 36, 100);
			Assets.fFontLo.render(stater.bd, " lvl." + player.shpow[1], 36 + 121 + 1, 128 + 36 + 1 + 12, 100);
			Assets.fFontMi.render(stater.bd, " lvl." + player.shpow[1], 36 + 121, 128 + 36 + 12, 100);
			
			Assets.fFontLo.render(stater.bd, "Ninja", 39 + 64 + 1, 96 + 10 + 1, 100);
			Assets.fFontHi.render(stater.bd, "Ninja", 39 + 64, 96 + 10, 100);
			Assets.fFontLo.render(stater.bd, "lvl." + player.shpow[2], 39 + 64 + 1, 96 + 10 + 1 + 12, 100);
			Assets.fFontMi.render(stater.bd, "lvl." + player.shpow[2], 39 + 64, 96 + 10 + 12, 100);
			
			Assets.fFontLo.render(stater.bd, "Furball", 39 + 60 + 1, 96 + 124 + 1, 100);
			Assets.fFontHi.render(stater.bd, "Furball", 39 + 60, 96 + 124, 100);
			Assets.fFontLo.render(stater.bd, " lvl." + player.shpow[3], 39 + 60 + 1, 96 + 124 + 1 + 12, 100);
			Assets.fFontMi.render(stater.bd, " lvl." + player.shpow[3], 39 + 60, 96 + 124 + 12, 100);
			
			if (player.shpow[1] == 0){
				stater.bd.copyPixels(Assets.aGUI, 36 + 121 + 10, 128 + 5, 176, 0, 24, 38);
			}
			if (player.shpow[2] == 0){
				stater.bd.copyPixels(Assets.aGUI, 39 + 64 + 5, 75, 176, 0, 24, 38);
			}
			if (player.shpow[3] == 0){
				stater.bd.copyPixels(Assets.aGUI, 39 + 64 + 5, 75 + 114, 176, 0, 24, 38);
			}
			switch (player.sh){
				case 0:
				stater.bd.copyPixels(Assets.aGUI, 30, 110, 0, 184, 93, 84);
				case 1:
				stater.bd.copyPixels(Assets.aGUI, 117, 110, 93, 184, 93, 84);
				case 2:
				stater.bd.copyPixels(Assets.aGUI, 78, 62, 0, 268, 84, 93);
				case 3:
				stater.bd.copyPixels(Assets.aGUI, 78, 149, 84, 268, 84, 93);
			}
		}
		
		if (hintsh){
			stater.bd.copyPixels(Assets.aGUI, 8, 320 - 48 - 8, 0, 361, 224, 48);
			Assets.fFontLo.render(stater.bd, hint[hintsub], 58 + 1, 320 - 45 + 1, 100);
			Assets.fFontMi.render(stater.bd, hint[hintsub], 58, 320 - 45, 100);
		} else {
			stater.bd.copyPixels(bds[0], 8, 320 - 8 - 12, 136, 112, 63, 12);
			stater.bd.copyPixels(bds[0], 8, 320 - 8 - 12, 136, 124, 12 + (player.hp >> 1), 12);
			for (i in 0...player.lives){
				stater.bd.copyPixels(bds[0], 79 - 8 + i * 14, 320 - 8 - 14, 0, 8, 16, 16);
			}
			var sc:String = "" + (scorelvl + scoretot);
			Assets.fFontLo.render(stater.bd, sc, 240 - 12 - sc.length * 6 + 1, 320 - 16 + 1, 100);
			Assets.fFontHi.render(stater.bd, sc, 240 - 12 - sc.length * 6, 320 - 16, 100);
			if (boss){
				stater.bd.fillRect(20, 8, FM.floor(bosshp / 5), 8, pal[7]);
			}
		}
		
		if (lvl.ph < 60 && !boss){
			Assets.fFontLo.render(stater.bd, "                LEVEL " + (lvl.num + 1) + ":", 1, 32 + 1, 100);
			Assets.fFontHi.render(stater.bd, "                LEVEL " + (lvl.num + 1) + ":", 0, 32, 100);
			Assets.fFontLo.render(stater.bd, lvl.title, 120 - (lvl.title.length * 3) + 1, 48 + 1, 100);
			Assets.fFontHi.render(stater.bd, lvl.title, 120 - (lvl.title.length * 3), 48, 100);
		}
		
		if (lvlover){
			Assets.fFontLo.render(stater.bd, "              LEVEL CLEAR!", 1, 32 + 1, 100);
			Assets.fFontHi.render(stater.bd, "              LEVEL CLEAR!", 0, 32, 100);
			if (lvloph < 100){
				var pfbonus:Int = player.hit ? 0 : 5000;
				Assets.fFontLo.render(stater.bd, "              Level score:", 1, 56 + 1, 100);
				Assets.fFontHi.render(stater.bd, "              Level score:", 0, 56, 100);
				Assets.fFontLo.render(stater.bd, "              0", 1, 72 + 1, 100);
				Assets.fFontHi.render(stater.bd, "              0", 0, 72, 100);
				Assets.fFontLo.render(stater.bd, "              Total score:", 1, 96 + 1, 100);
				Assets.fFontHi.render(stater.bd, "              Total score:", 0, 96, 100);
				Assets.fFontLo.render(stater.bd, "              " + (scoretot + scorelvl + pfbonus), 1, 112 + 1, 100);
				Assets.fFontHi.render(stater.bd, "              " + (scoretot + scorelvl + pfbonus), 0, 112, 100);
				if (!player.hit){
					Assets.fFontLo.render(stater.bd, "              PURRFECT! +5000", 1, 136 + 1, 100);
					Assets.fFontHi.render(stater.bd, "              PURRFECT! +5000", 0, 136, 100);
				}
				if (lvloph == 0){
					Assets.fFontLo.render(stater.bd, "          Press A to continue!", 1, 160 + 1, 100);
					Assets.fFontHi.render(stater.bd, "          Press A to continue!", 0, 160, 100);
				}
			} else if (lvloph < 160){
				var conv:Int = FM.floor(scorelvl * (1 - (lvloph - 100) / 60));
				Assets.fFontLo.render(stater.bd, "              Level score:", 1, 56 + 1, 100);
				Assets.fFontHi.render(stater.bd, "              Level score:", 0, 56, 100);
				Assets.fFontLo.render(stater.bd, "              " + (scorelvl - conv), 1, 72 + 1, 100);
				Assets.fFontHi.render(stater.bd, "              " + (scorelvl - conv), 0, 72, 100);
				Assets.fFontLo.render(stater.bd, "              Total score:", 1, 96 + 1, 100);
				Assets.fFontHi.render(stater.bd, "              Total score:", 0, 96, 100);
				Assets.fFontLo.render(stater.bd, "              " + (scoretot + conv), 1, 112 + 1, 100);
				Assets.fFontHi.render(stater.bd, "              " + (scoretot + conv), 0, 112, 100);
			} else if (lvloph < 260){
				Assets.fFontLo.render(stater.bd, "              Level score:", 1, 56 + 1, 100);
				Assets.fFontHi.render(stater.bd, "              Level score:", 0, 56, 100);
				if (lvloph < 240){
					Assets.fFontLo.render(stater.bd, "              " + scorelvl, 1, 72 + 1, 100);
					Assets.fFontHi.render(stater.bd, "              " + scorelvl, 0, 72, 100);
					if (lvloph < 220){
						Assets.fFontLo.render(stater.bd, "              Total score:", 1, 96 + 1, 100);
						Assets.fFontHi.render(stater.bd, "              Total score:", 0, 96, 100);
						if (lvloph < 200){
							Assets.fFontLo.render(stater.bd, "              " + scoretot, 1, 112 + 1, 100);
							Assets.fFontHi.render(stater.bd, "              " + scoretot, 0, 112, 100);
						}
					}
				}
			}
			
			if (lvloph > 0) lvloph--;
		}
		
		stater.bd.copyPixels(player.dbg_bd, 0, 0, 0, 0, 240, 320);
	}
	
	override public function kUp(kc:Int):Void {
		if (lvlover && (kc == Keyboard.K_A || kc == Keyboard.K_SPACE)){
			if (lvloph > 0){
				lvloph -= 20;
				if (lvloph < 0) lvloph = 0;
			} else {
				cont = true;
				if (lvl.num < 3){
					setLevel(lvl.num + 1);
				} else {
					if (mplaying != null) mplaying.stop();
					Main.inst.applyState(Main.inst.getStateById("victory"));
				}
			}
		} else if (hintsh && (kc == Keyboard.K_A || kc == Keyboard.K_SPACE)){
			hintsub++;
			if (hintsub >= hint.length){
				hintsub = 0;
				hint = [];
				hintsh = false;
			}
		}
	}
}

class Star {
	public var x:Int;
	public var y:Int;
	public var sp:Int;
	public var ph:Int = 0;
	public var sz:Int = 0;
	public var bph:Int = 0;
	public var bf:Int;
	
	public function new(){
		reset();
		y = Main.prng.nextMod(320);
	}
	
	public inline function reset(){
		x = Main.prng.nextMod(240);
		y = 0;
		ph = 0;
		bph = 0;
		bf = Main.prng.nextMod(60) + 4;
		sp = Main.prng.nextMod(15);
		sz = Main.prng.nextMod(14) > 10 ? (Main.prng.nextMod(10) > 6 ? 3 : 2) : 1;
	}
}