package game;

import haxe.ds.Vector;
import sk.thenet.FM;
import sk.thenet.app.*;
import sk.thenet.bmp.*;

class GSIntro extends SSApp {
	public var bds:Array<BitmapData>;
	public var pal:Array<UInt>;
	public var ph:Int;
	public var mbd:BitmapData;
	
	public function new(nstater){
		super("intro", nstater);
		bds = [
			for (i in 0...6){
				Assets.aIntro.cut(0, 8 + (9 * 8) * i, 12 * 8, 9 * 8);
			}
		];
		bds.push(Assets.aIntro.cut(12 * 8, 8 + 9 * 8, 64, 16));
		bds.push(Assets.aIntro.cut(12 * 8, 8 + 9 * 8 + 16, 64, 24));
		bds.push(Assets.aIntro.cut(12 * 8, 8 + 9 * 8 + 16 + 24, 64, 32));
		bds.push(Assets.aIntro.cut(12 * 8, 8 + 4 * 9 * 8, 12 * 8, 9 * 8));
		bds.push(Assets.aIntro.cut(12 * 8, 8 + 5 * 9 * 8, 12 * 8, 9 * 8));
		bds.push(Assets.aIntro.cut(24 * 8, 8 + 5 * 9 * 8, 16, 24));
		bds.push(Assets.aIntro.cut(24 * 8 + 16, 8 + 5 * 9 * 8, 16, 24));
		pal = [
			for (i in 0...11){
				Assets.aIntro.get(i * 8, 0);
			}
		];
		mbd = new BitmapData(96, 72, 0);
	}
	
	override public function to():Void {
		stater.bd.fill(pal[0]);
		ph = 0;
	}
	
	public function makeClouds(mov:Int):Void {
		mbd.copyPixels(bds[1], 0, 0, 0, 0, 96, 72);
		mbd.copyPixels(bds[6], 48 + (mov >> 1), 12, 0, 0, 64, 16);
		mbd.copyPixels(bds[7], 35 + (mov >> 2), 32, 0, 0, 64, 24);
		mbd.copyPixels(bds[8], 0 - (mov >> 1), 24, 0, 0, 64, 32);
	}
	
	override public function tick():Void {
		if (ph < 60){
			Assets.fFontMi.render(stater.bd, "Press any key to skip intro.", 8, 8, 100);
		}
		
		if (ph >= 90 && ph < 240){
			var ov = bds[0].getFullVector();
			var v = stater.bd.getVector(32, 32, 96, 72);
			for (i in 0...200){
				var j = Main.prng.nextMod(v.length);
				v[j] = ov[j];
			}
			stater.bd.setVector(v, 32, 32, 96, 72);
		} else if (ph == 240){
			stater.bd.copyPixels(bds[0], 32, 32, 0, 0, 96, 72);
		} else if (ph == 280){
			Noises.playIntro1();
			Assets.fFontMi.render(stater.bd, "12:01 a.m.", 32, 120, 100);
			makeClouds(0);
		} else if (ph >= 300 && ph < 480){
			makeClouds((ph - 300) >> 3);
			var ov = mbd.getFullVector();
			var v = stater.bd.getVector(104, 62, 96, 72);
			for (i in 0...300){
				var j = Main.prng.nextMod(v.length);
				v[j] = ov[j];
			}
			stater.bd.setVector(v, 104, 62, 96, 72);
		} else if (ph == 480){
			stater.bd.copyPixels(mbd, 104, 62, 0, 0, 96, 72);
		} else if (ph >= 500 && ph <= 610){
			if (ph % 16 == 0) Noises.playIntro3();
			var s:String = "WHAT A HORRIBLE NIGHT\nTO HAVE A CURSE! ";
			s = s.substr(0, FM.floor(((ph - 500) / 110) * s.length));
			Assets.fFontMi.render(stater.bd, s, 42, 160, 100);
		} else if (ph == 620){
			stater.bd.copyPixels(bds[2], 48, 192, 0, 0, 96, 72);
		} else if (ph >= 640 && ph < 820){
			if (ph == 640) Noises.playIntro2();
			var ov = bds[3].getFullVector();
			var v = stater.bd.getVector(48, 192, 96, 72);
			for (i in 0...200){
				var j = Main.prng.nextMod(v.length);
				v[j] = ov[j];
			}
			stater.bd.setVector(v, 48, 192, 96, 72);
		} else if (ph == 820){
			stater.bd.copyPixels(bds[3], 48, 192, 0, 0, 96, 72);
		} else if (ph >= 840 && ph < 840 + 180){
			var ov = bds[4].getFullVector();
			var v = stater.bd.getVector(48 + 16, 192 + 16, 96, 72);
			for (i in 0...200){
				var j = Main.prng.nextMod(v.length);
				v[j] = ov[j];
			}
			stater.bd.setVector(v, 48 + 16, 192 + 16, 96, 72);
		} else if (ph == 1020){
			stater.bd.copyPixels(bds[4], 48 + 16, 192 + 16, 0, 0, 96, 72);
		} else if (ph == 1040){
			Noises.playCrush();
			stater.bd.copyPixels(bds[9], 48 + 16, 192 + 16, 0, 0, 96, 72);
		} else if (ph == 1080){
			Noises.playMeow();
			Assets.fFontMi.render(stater.bd, "Meow!", 32, 192 + 16 + 72 + 8, 100);
			mbd.copyPixels(bds[5], 0, 0, 0, 0, 96, 72);
			mbd.copyPixels(bds[11], 38, 16, 0, 0, 16, 24);
		} else if (ph >= 1120 && ph < 1300){
			var ov = mbd.getFullVector();
			var v = stater.bd.getVector(48 + 32, 192 + 32, 96, 72);
			for (i in 0...300){
				var j = Main.prng.nextMod(v.length);
				v[j] = ov[j];
			}
			stater.bd.setVector(v, 48 + 32, 192 + 32, 96, 72);
		} else if (ph == 1300){
			stater.bd.copyPixels(mbd, 48 + 32, 192 + 32, 0, 0, 96, 72);
		} else if (ph == 1340){
			Noises.playHurt();
			stater.bd.copyPixels(bds[5], 48 + 32, 192 + 32, 0, 0, 96, 72);
			stater.bd.copyPixels(bds[12], 48 + 32 + 38 - 1, 192 + 32 + 16, 0, 0, 16, 24);
		} else if (ph == 1390){
			Noises.playBossClear();
			stater.bd.copyPixels(bds[5], 48 + 32, 192 + 32, 0, 0, 96, 72);
			stater.bd.copyPixels(bds[10], 48 + 32, 192 + 32, 0, 0, 96, 72);
		} else if (ph == 1450){
			Main.inst.applyState(Main.inst.getStateById("game"));
		}
		
		ph++;
	}
	
	override public function kUp(kc:Int):Void {
		Main.inst.applyState(Main.inst.getStateById("game"));
	}
}