package game;

import sk.thenet.FM;

class Wave {
	public static inline var WT_DOWN:Int = 0;
	public static inline var WT_DOWNLEFT:Int = 1;
	public static inline var WT_DOWNRIGHT:Int = 2;
	public static inline var WT_SWOOPLEFT:Int = 3;
	public static inline var WT_SWOOPRIGHT:Int = 4;
	public static inline var WT_SWIGGLELEFT:Int = 5;
	public static inline var WT_SWIGGLERIGHT:Int = 6;
	public static inline var WT_LEFT:Int = 7;
	public static inline var WT_RIGHT:Int = 8;
	public static inline var WT_SWIGGLEFROMLEFT:Int = 9;
	public static inline var WT_SWIGGLEFROMRIGHT:Int = 10;
	public static inline var WT_LEFTSLOWDOWN:Int = 11;
	public static inline var WT_RIGHTSLOWDOWN:Int = 12;
	public static inline var WT_STATIONARY:Int = 13;
	public static inline var WT_LEFTSLOWDOWN_PASS:Int = 14;
	public static inline var WT_RIGHTSLOWDOWN_PASS:Int = 15;
	
	public static var W_MOVEFUNC:Array<Wave->Int->EEnemy->Void> = [
		// WT_DOWN
		function(wave:Wave, ph:Int, e:EEnemy):Void {
			e.x = wave.x;
			e.y = -16 + ph * 2;
			if (e.y >= 330){
				e.spawner.oob(e);
			}
		},
		// WT_DOWNLEFT
		function(wave:Wave, ph:Int, e:EEnemy):Void {
			if (ph >= wave.arg){
				e.x = wave.x - (ph - wave.arg) * 2;
				e.y = -16 + wave.arg * 2;
			} else {
				e.x = wave.x;
				e.y = -16 + ph * 2;
			}
			if (e.x < -10){
				e.spawner.oob(e);
			}
		},
		// WT_DOWNRIGHT
		function(wave:Wave, ph:Int, e:EEnemy):Void {
			if (ph >= wave.arg){
				e.x = wave.x + (ph - wave.arg) * 2;
				e.y = -16 + wave.arg * 2;
			} else {
				e.x = wave.x;
				e.y = -16 + ph * 2;
			}
			if (e.x > 250){
				e.spawner.oob(e);
			}
		},
		// WT_SWOOPLEFT
		function(wave:Wave, ph:Int, e:EEnemy):Void {
			e.x = wave.x + FM.floor(Math.sin(ph / 30) * 190);
			e.y = -16 + ph * 3;
			if (e.x < -10 || e.y >= 330){
				e.spawner.oob(e);
			}
		},
		// WT_SWOOPRIGHT
		function(wave:Wave, ph:Int, e:EEnemy):Void {
			e.x = wave.x - FM.floor(Math.sin(ph / 30) * 190);
			e.y = -16 + ph * 3;
			if (e.x > 250 || e.y >= 330){
				e.spawner.oob(e);
			}
		},
		// WT_SWIGGLELEFT
		function(wave:Wave, ph:Int, e:EEnemy):Void {
			e.x = wave.x + FM.floor(Math.cos(ph / wave.arg) * 90);
			e.y = -16 + ph * 2;
			if (e.y >= 330){
				e.spawner.oob(e);
			}
		},
		// WT_SWIGGLERIGHT
		function(wave:Wave, ph:Int, e:EEnemy):Void {
			e.x = wave.x - FM.floor(Math.cos(ph / wave.arg) * 90);
			e.y = -16 + ph * 2;
			if (e.y >= 330){
				e.spawner.oob(e);
			}
		},
		// WT_LEFT
		function(wave:Wave, ph:Int, e:EEnemy):Void {
			e.x = -16 + ph * 2;
			e.y = wave.x;
			if (e.x >= 330){
				e.spawner.oob(e);
			}
		},
		// WT_RIGHT
		function(wave:Wave, ph:Int, e:EEnemy):Void {
			e.x = 336 - ph * 2;
			e.y = wave.x;
			if (e.x < -10){
				e.spawner.oob(e);
			}
		},
		// WT_SWIGGLEFROMLEFT
		function(wave:Wave, ph:Int, e:EEnemy):Void {
			e.x = -16 + ph * 2;
			e.y = wave.x + FM.floor(Math.cos(ph / wave.arg) * 90);
			if (e.x >= 330){
				e.spawner.oob(e);
			}
		},
		// WT_SWIGGLEFROMRIGHT
		function(wave:Wave, ph:Int, e:EEnemy):Void {
			e.x = 336 - ph * 2;
			e.y = wave.x + FM.floor(Math.cos(ph / wave.arg) * 90);
			if (e.x < -10){
				e.spawner.oob(e);
			}
		},
		// WT_LEFTSLOWDOWN
		function(wave:Wave, ph:Int, e:EEnemy):Void {
			e.x = -16 + ph * 2 + FM.floor(10 * (Math.sin((ph / wave.arg) * 6.28)));
			e.y = wave.x;
			if (e.x >= 330){
				e.spawner.oob(e);
			}
		},
		// WT_RIGHTSLOWDOWN
		function(wave:Wave, ph:Int, e:EEnemy):Void {
			e.x = 256 - ph * 2 - FM.floor(10 * (Math.sin((ph / wave.arg) * 6.28)));
			e.y = wave.x;
			if (e.x < -10){
				e.spawner.oob(e);
			}
		},
		// WT_STATIONARY
		function(wave:Wave, ph:Int, e:EEnemy):Void {
			e.x = wave.x;
			e.y = -16 + ph;
			if (e.y >= 370){
				e.spawner.oob(e);
			}
		},
		// WT_LEFTSLOWDOWN_PASS
		function(wave:Wave, ph:Int, e:EEnemy):Void {
			e.x = -16 + ph * 2 + FM.floor(10 * (Math.sin((ph / wave.arg) * 6.28)));
			e.y = wave.x + ph;
			if (e.x >= 330){
				e.spawner.oob(e);
			}
		},
		// WT_RIGHTSLOWDOWN_PASS
		function(wave:Wave, ph:Int, e:EEnemy):Void {
			e.x = 256 - ph * 2 - FM.floor(10 * (Math.sin((ph / wave.arg) * 6.28)));
			e.y = wave.x + ph;
			if (e.x < -10){
				e.spawner.oob(e);
			}
		},
	];
	
	public static inline var WR_NONE:Int = 0;
	public static inline var WR_TREATS:Int = 1;
	public static inline var WR_LEVELR:Int = 2;
	public static inline var WR_LEVELL:Int = 3;
	public static inline var WR_LEVELN:Int = 4;
	public static inline var WR_LEVELF:Int = 5;
	public static inline var WR_LIFE:Int = 6;
	
	public var time:Int = 0;
	public var type:Int;
	public var enemy:Class<EEnemy>;
	public var amount:Int;
	public var reward:Int;
	public var x:Int;
	public var arg:Int;
	
	public function new(ntype:Int, nenemy:Class<EEnemy>, namount:Int, nx:Int, narg:Int, nreward:Int = 0){
		type = ntype;
		enemy = nenemy;
		amount = namount;
		x = nx;
		arg = narg;
		reward = nreward;
	}
	
	public function activate(ngs:GSGame):Spawner {
		return new Spawner(this, ngs);
	}
}

class Spawner {
	public var wave:Wave;
	public var gs:GSGame;
	public var ph:Int = 0;
	public var spawned:Int = 0;
	public var gone:Int = 0;
	public var killed:Int = 0;
	public var remove:Bool = false;
	
	public function new(nwave:Wave, ngs:GSGame){
		wave = nwave;
		gs = ngs;
	}
	
	public function oob(e:EEnemy):Void {
		e.remove = true;
		gone++;
	}
	
	public function kill(e:EEnemy):Void {
		gone++;
		killed++;
		if (killed >= wave.amount){
			if (wave.amount != 1){
				Noises.playWaveClear();
				gs.scorelvl += 1000;
			}
			switch (wave.reward){
				case Wave.WR_TREATS:
				for (i in 0...10){
					gs.addEntity(new ECollect(gs, e.x, e.y, ECollect.CT_TREAT));
				}
				case Wave.WR_LEVELR | Wave.WR_LEVELL | Wave.WR_LEVELN | Wave.WR_LEVELF:
				gs.addEntity(new ECollect(gs, e.x, e.y, ECollect.CT_LEVELR + (wave.reward - Wave.WR_LEVELR)));
				case Wave.WR_LIFE:
				gs.addEntity(new ECollect(gs, e.x, e.y, ECollect.CT_LIFE));
			}
		}
	}
	
	public function tick():Void {
		if (spawned < wave.amount){
			if (ph == 0){
				gs.addEntity(Type.createInstance(wave.enemy,
					[gs, this, Wave.W_MOVEFUNC[wave.type].bind(wave, _, _)]));
				spawned++;
			}
			ph++;
			if (ph >= 20){
				ph = 0;
			}
		} else {
			if (gone == wave.amount){
				remove = true;
			}
		}
	}
}