package sk.thenet.plustd.audio.music;

import haxe.ds.Vector;

class MMEADSR extends MMEffect {
	public var atk:Float;
	public var dec:Float;
	public var sus:Float;
	public var rel:Float;
	public var envph:Int;
	
	public function new(natk:Float, ndec:Float, nsus:Float, nrel:Float):Void {
		super();
		gate_always = true;
		atk = natk;
		dec = ndec;
		sus = nsus;
		rel = nrel;
		reset();
	}
	
	override public function reset():Void {
		super.reset();
		envph = 0;
	}
	
	override public function trigger(trig:Int, ttype:Int):Void {
		if (triggered) return;
		triggered = true;
		if (trig > 0){
			ph = 0;
			envph = 0;
		} else if (trig < 0){
			if (!persist_trigger) done = true;
			ph = 0;
			envph = 1;
		}
	}
	
	override public function apply(buf:Float):Float {
		var subph:Float = 0;
		var phf:Float = 0;
		if (envph == 0){
			if (ph >= atk + dec) phf = sus;
			else if (ph >= atk){
				subph = ((ph - atk) / dec);
				phf = (1 - subph) + (subph * sus);
			} else phf = ph / atk;
		} else {
			if (ph >= rel) phf = 0;
			else phf = (1 - ph / rel) * sus;
		}
		ph++;
		return buf * phf;
	}
}