package sk.thenet.plustd.audio.music;

import haxe.ds.Vector;

class MMEBandPass extends MMEffect {
	public var cf:Float; // center frequency
	public var bw:Float; // bandwidth
	public var lval1:Float; // last values
	public var lval2:Float;
	public var a:Float;
	public var b:Float;
	public var c:Float;
	
	public function new(ncf:Float, nbw:Float, nnoise:Bool):Void {
		super();
		setParams(ncf, nbw, nnoise);
		reset();
	}
	
	public function setParams(ncf:Float, nbw:Float, nnoise:Bool):Void {
		cf = ncf;
		bw = nbw;
		c = Math.exp(-2 * Math.PI * (nbw / MusicManager.SAMPLERATE));
		b = -4 * c / (1 + c) * Math.cos(2 * Math.PI * (cf / MusicManager.SAMPLERATE));
		a = Math.sqrt(1 - b * b / (4 * c)) * (1 - c);
		if (nnoise){
			a *= Math.sqrt(((1 + c) * (1 + c) - b * b) * (1 - c) / (1 + c)) / a;
		}
	}
	
	override public function reset():Void {
		super.reset();
		lval1 = 0;
		lval2 = 0;
	}
	
	override public function trigger(trig:Int, ttype:Int):Void {
		if (triggered) return;
		triggered = true;
		if (trig > 0){
			gate = 1;
		} else if (trig < 0){
			if (!persist_trigger) done = true;
			gate = 0;
		}
	}
	
	override public function apply(buf:Float):Float {
		if (gate > 0){
			buf = a * buf - b * lval1 - c * lval2;
			lval2 = lval1;
			lval1 = buf;
		}
		return buf;
	}
}