package sk.thenet.plustd.audio.music;

import haxe.ds.Vector;

class MMEEcho extends MMEffect {
	public var echobuf:Vector<Float>;
	public var pos:Int;
	public var mul:Float;
	
	public function new(nsamples:Int, nmul:Float):Void {
		super();
		echobuf = new Vector<Float>(nsamples);
		for (i in 0...nsamples) echobuf[i] = 0;
		mul = nmul;
		reset();
	}
	
	override public function reset():Void {
		super.reset();
		pos = 0;
		for (i in 0...echobuf.length) echobuf[i] = 0;
	}
	
	override public function apply(buf:Float):Float {
		echobuf[pos] *= mul;
		echobuf[pos] = buf = buf + echobuf[pos];
		pos++;
		pos %= echobuf.length;
		return buf;
	}
}