package sk.thenet.plustd.audio.music;

import haxe.ds.Vector;

class MMESlide extends MMEffect {
	public var add:Bool;
	public var speed:Float;
	public var off:Float;
	
	public function new(nadd:Bool, noff:Float, nspeed:Float):Void {
		super();
		tapl = MMEffect.ETA_NOTES;
		add = nadd;
		off = noff;
		speed = nspeed;
		reset();
	}
	
	override public function trigger(trig:Int, ttype:Int):Void {
		if (triggered) return;
		triggered = true;
		if (trig > 0 && gate == 0){
			ph = 0;
			gate = 1;
		} else if (trig != 0){
			done = true;
			gate = 0;
		}
	}
	
	override public function applyNotes(instr:MMInstrument, c:Int):Void {
		if (gate > 0){
			var phf:Float = ph / speed;
			instr.notes += (add ? phf * off : (1 - phf) * off);
			instr.freq = MusicManager.indexToFreq(instr.notes);
			instr.trig = (instr.trig == 0 ? 2 : instr.trig);
			ph += 1;
		}
		if (ph >= speed) done = true;
	}
}