package sk.thenet.plustd.audio.music;

import haxe.ds.Vector;
import sk.thenet.FM;

class MMIWave extends MMInstrument {
	public static inline var WT_SINE:Int = 0;
	public static inline var WT_TRIANGLE:Int = 1;
	public static inline var WT_SQUARE:Int = 2;
	public static inline var WT_WSINE:Int = 3;
	public static inline var WT_TECHBRAS:Int = 4;
	
	public var wavetype:Int = 0;
	public var duty:Float = .5;
	
	public function new(nwavetype:Int){
		super();
		wavetype = nwavetype;
	}
	
	override public inline function buffer():Float {
		var val:Float = 0;
		if (gate > 0){
			var phf:Float = (ph / lfreq);
			val = switch (wavetype){
				case WT_SINE: Math.sin(phf < duty ? ((phf / duty) * Math.PI)
					: ((phf - duty) / (1 - duty)) * Math.PI + Math.PI);
				case WT_WSINE: Math.sin(phf < duty ? ((phf / duty) * Math.PI * 2)
					: ((phf - duty) / (1 - duty)) * Math.PI * 2 + Math.PI);
				case WT_TRIANGLE: (phf < .25 ? phf / .25 : (phf < .75 ? 1 - (phf - .25) / .25 : (phf - .75) / .25 - 1));
				case WT_SQUARE: phf < duty ? .5 : -.5;
				case WT_TECHBRAS:
				Math.sin(phf < duty ? phf * Math.PI : -phf * Math.PI)
					+ Math.sin(13 * phf * Math.PI) * .3
					+ Math.sin(7 * phf * Math.PI) * .2
					+ Math.sin(3 * phf * Math.PI) * .1;
				case _: 0;
			};
		}
		return val;
	}
}