package sk.thenet.prog;

import sk.thenet.model.Point2D;
import sk.thenet.FM;
import sk.thenet.bmp.*;

class LGXiaolinWu implements LineGenerator<Int> {
	public function new(nx1:Float, ny1:Float, x2:Float, y2:Float){
		
	}
	
	public inline function hasNext():Bool {
		return false;
	}
	
	public inline function next():Point2D<Int> {
		var ret:Point2D<Int> = null;
		return ret;
	}
	
	public inline function getAll(xmin:Int, ymin:Int, xmax:Int, ymax:Int):Array<Point2D<Int>> {
		var ret = [
			while (hasNext()){
				next();
			}
		];
		return ret;
	}
	
	public static function plot(bd:BitmapData, c:UInt, x1:Float, y1:Float, x2:Float, y2:Float):Void {
		var steep = FM.absF(y2 - y1) > FM.absF(x2 - x1);
		var t:Float = 0;
		if (steep){
			t = x1;
			x1 = y1;
			y1 = t;
			t = x2;
			x2 = y2;
			y2 = t;
		}
		if (x1 > x2){
			t = x1;
			x1 = x2;
			x2 = t;
			t = y1;
			y1 = y2;
			y2 = t;
		}
		var dx:Float = x2 - x1;
		var dy:Float = y2 - y1;
		var grad:Float = dy / dx;
		
		var xend:Int = FM.round(x1);
		var yend:Float = y1 + grad * (xend - x1);
		var xgap:Float = 1 - FM.frac(x1 + .5);
		
		var xpxl1:Int = xend;
		var ypxl1:Int = FM.floor(yend);
		
		if (steep){
			bd.setAlpha(ypxl1, xpxl1, c, (1 - FM.frac(yend)) * xgap);
			bd.setAlpha(ypxl1 + 1, xpxl1, c, FM.frac(yend) * xgap);
		} else {
			bd.setAlpha(xpxl1, ypxl1, c, (1 - FM.frac(yend)) * xgap);
			bd.setAlpha(xpxl1, ypxl1 + 1, c, FM.frac(yend) * xgap);
		}
		
		var intery:Float = yend + grad;
		
		xend = FM.round(x2);
		yend = y2 + grad * (xend - x2);
		xgap = FM.frac(x2 + .5);
		
		var xpxl2:Int = xend;
		var ypxl2:Int = FM.floor(yend);
		
		if (steep){
			bd.setAlpha(ypxl2, xpxl2, c, (1 - FM.frac(yend)) * xgap);
			bd.setAlpha(ypxl2 + 1, xpxl2, c, FM.frac(yend) * xgap);
		} else {
			bd.setAlpha(xpxl2, ypxl2, c, (1 - FM.frac(yend)) * xgap);
			bd.setAlpha(xpxl2, ypxl2 + 1, c, FM.frac(yend) * xgap);
		}
		
		for (x in (xpxl1 + 1)...xpxl2){
			if (steep){
				bd.setAlpha(FM.floor(intery), x, c, 1 - FM.frac(intery));
				bd.setAlpha(FM.floor(intery) + 1, x, c, FM.frac(intery));
			} else {
				bd.setAlpha(x, FM.floor(intery), c, 1 - FM.frac(intery));
				bd.setAlpha(x, FM.floor(intery) + 1, c, FM.frac(intery));
			}
			intery = intery + grad;
		}
	}
}