package sk.thenet.prog;

class PRNGParkMiller implements PRNGenerator {
	public var s:UInt;
	public var g:UInt = 16807;
	public var n:UInt = 2147483647;
	
	public function new(ns:UInt = 1){
		s = ns;
	}
	
	public inline function seed(ns:UInt):Void {
		s = ns;
	}
	
	public inline function next():UInt {
		return s = (s * g) % n;
	}
	
	public inline function nextMod(max:UInt):UInt {
		return next() % max;
	}
	
	public inline function nextFloat(max:Float = 1):Float {
		return (next() / n) * max;
	}
}