package sk.thenet.prog;

class PRNGXORShift implements PRNGenerator {
	public var x:UInt;
	public var y:UInt;
	public var z:UInt;
	public var s:UInt;
	
	private var t:UInt;
	
	public function new(ns:UInt = 1){
		s = ns;
		x = ns << 1;
		y = ns << 2;
		z = ns << 3;
	}
	
	public inline function seed(ns:UInt):Void {
		s = ns;
		x = ns << 1;
		y = ns << 2;
		z = ns << 3;
	}
	
	public inline function next():UInt {
		t = x;
		t ^= t << 11;
		t ^= t >> 8;
		x = y;
		y = z;
		z = s;
		s ^= s >> 19;
		s ^= t;
		return s;
	}
	
	public inline function nextMod(max:UInt):UInt {
		return next() % max;
	}
	
	public inline function nextFloat(max:Float = 1):Float {
		return (next() / 2147483647) * max;
	}
}